﻿local bbs2util = require "bbs2util"

function data()
return {
	tracks = {
	-- Soundmitschnitte überwiegend aus: https://www.youtube.com/watch?v=8p89-RDCOww
		{ name = "vehicle/br01/01_stand.wav", refDist = 15.0 },
		{ name = "vehicle/br01/01_leer.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_4.wav", refDist = 25.0 },		
		{ name = "vehicle/br01/01_8.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_12.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_16.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_20b.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_24.wav", refDist = 25.0 },
		{ name = "vehicle/br01/01_28.wav", refDist = 25.0 },		
		{ name = "vehicle/br01/kurve.wav", refDist = 20.0 },
		{ name = "vehicle/br01/bremse_dampf.wav", refDist = 20.0 },
		{ name = "vehicle/br01/bremsluft.wav", refDist = 20.0 },

	},
	events =  {
		horn = { names = { "vehicle/br01/01_horn.wav" }, refDist = 25.0 },
		closeDoors = { names = { "vehicle/br01/dampf.wav" }, refDist = 15.0 }
		
	},

	updateFn = function (input)
		local speed01 = input.speed / input.topSpeed
		local refWeight = 15.0	
		local axleRefWeight = 10.0
		
		return {
			tracks = {
			--stand	
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, 1.0 },
									{ .01, .2 },
									{ 1.0, .2 } }, input.speed01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 1.0 },
									{ 1.0, 1.0 } }, input.speed01)
				},
			--Leerlauf	
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, 0.8 },
									{ .2, 0.6 },
									{ .4, 0.4 },
									{ 1.0, 0.4 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .30, 0.0 },
									{ .3001, 0.8 },
									{ 1.0, 1.4 } }, input.speed01)
				},	
			--Fahrt 4 
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .4 },
									{ 0.4, 1.0 },
									{ 1.0, 1.2 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .001, 0.75 },
									{ .125, 1.5 },
									{ .1251, 0.0 },
									{ 1.0, 0.0 } }, input.speed01)
				},			

			--Fahrt 8 
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .4 },
									{ 0.4, 1.0 },
									{ 1.0, 1.25 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .125, 0.0 },
									{ .1251, 0.75 },
									{ .29, 1.25 },
									{ .2901, 0.0 },
									{ 1.0, 0.0 } }, input.speed01)
				},
			--Fahrt 12 
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .4 },
									{ 0.4, 1.0 },
									{ 1.0, 1.3 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .29, 0.0 },
									{ .2901, 0.84 },
									{ .41, 1.17 },
									{ .4101, 0.0 },
									{ 1.0, 0.0 } }, input.speed01)
				},
			--Fahrt 16
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .4 },
									{ 0.4, 1.1 },
									{ 1.0, 1.35 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .41, 0.0 },
									{ .4101, 0.88 },
									{ .55, 1.13 },
									{ .5501, 0.0 },
									{ 1.0, 0.0 } }, input.speed01)
				},				
			--Fahrt 20
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .5 },
									{ 0.4, 1.1 },
									{ 1.0, 1.4 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .55, 0.0 },
									{ .5501, 0.9 },
									{ .7, 1.2 },
									{ .701, 0.0 },									
									{ 1.0, 0.0 } }, input.speed01)
				},
			--Fahrt 24
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .65 },
									{ 0.4, 1.2 },
									{ 1.0, 1.45 } }, input.power01)*
										bbs2util.sampleCurve({ 
										{ .0, 1.0 },
										{ 0.95, 1.0 },
										{ 0.97, 0.45 },
										{ 1.0, 0.3 } }, input.speed01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .7, 0.0 },
									{ .701, 1.0 },
									{ .95, 1.16 },									
									{ 1.0, 1.23 } }, input.speed01)
				},												
			--Fahrt 28
				{ 
					gain = bbs2util.sampleCurve({ 
									{ .0, .7 },
									{ 0.4, 1.25 },
									{ 1.0, 1.5 } }, input.power01),
					pitch = bbs2util.sampleCurve({ 
									{ .0, 0.0 },
									{ .9, 0.0 },
									{ .951, 1.0 },									
									{ 1.0, 1.036 } }, input.speed01)
				},								
				bbs2util.squeal(input.speed, input.sideForce, input.maxSideForce),
				bbs2util.brake(input.speed, input.brakeDecel, 1.0),
				bbs2util.slow(input.speed, input.brakeDecel, 1.0),
				
			},
			events = {
						horn = { gain = 1.2, pitch = 1.0 },		
						closeDoors = { gain = 1.0, pitch = 1.0 }
			}
		}
	end
}
end
